//       :   (info@xhtml.ru)
//	 : AKS (aksus-69@yandex.ru)
//	   IE 6, Opera 7+, gecko(navigator.productSub >= 20040113)
//	 xhtml.ru  

// -   ,     
//   ,      DOM

function getId(id) {										//   									
	return document.getElementById(id);
}		

function getTags(obj, tag) {									//       								
	return obj.getElementsByTagName(tag);  
}

function changeStyle(obj, props) {								//       , 																		//     
	for(var i in props) {									//     
		obj.style[i] = props[i];
	}
}		

function attachSSEvents(el, props) {								//   (   ),   
	if(!el.attachEvent) 									//   
		el.attachEvent = function(e, fn) {
		return this.addEventListener(e.substr(2), fn, false);
	}
	for(var i in props) {
		el.attachEvent(i, props[i]);
	}
}

function getPosY(obj, prop) {									//      
	var p = obj.offsetParent, y = obj[prop];
        while(p) {
		y += p[prop];
		p = p.offsetParent;
	}	
        return y;
}

function preventEvent(e) {									//     , 
	var ev = e || window.event;								//      -									 
	if (ev.preventDefault) ev.preventDefault();						
	else ev.returnValue = false;								
	return false;
}

function createSSElement(parent, tag) {								//   ,      
	var i, elem = document.createElement(tag);						// ,      							
	parent.appendChild(elem);
	if(arguments[2]) {								
		changeStyle(elem, arguments[2]);		
	}
	if(arguments[3]) {
		attachSSEvents(elem, arguments[3]);
	}
	if(arguments[4]) {
		elem.appendChild(document.createTextNode(arguments[4]));
	}
	return elem;
}

// -  ,     , 
//     -					

function mainSSConstructor(prnt) {										
	var thzz = this;									
	var tempSlides = [];									//,      div.slide   												
	var next = 0;										//       
	function getNext(bl) { 									//    
		if(bl) next++; 									//next     
        	else  next--; 
		return next;
	}
	var active = -1;									//    								
	var timer = null;									//  -
	var px = "px";	
	var openStep = 14;									//     (    )
	var closeStep = -22;									//     (    )

// - ,          createSSElement()
// ,     -  	
					
	var topBar = createSSElement(prnt, "div", {						//,      ""
		"borderBottom" : "2px solid white", "padding" : "3px" });
	prnt.insertBefore(topBar, prnt.firstChild);						//   
	var navMenu = createSSElement(topBar, "span", {						// ""				
		"cursor" : "pointer", "backgroundColor" : "white",
		"padding" : "0px 3px", "color" : "black" }, { 
		"onmouseover" : function() { changeStyle(navMenu, { 
		"backgroundColor" : "#17507F", "color" : "white", 
		"border" : "1px solid white" }); 
		thzz.showSubMenu(); }, 
		"onmouseout" : function() { thzz.hideSubMenu(); }}, 
		"");
	var subMenu = createSSElement(document.body, "div", {					//-,    				 
		"position" : "absolute", "top" : "0px", "display" : "block" }, {		//onmouseover   "" 
		"onmouseover" : function() { changeStyle(navMenu, { 
		"backgroundColor" : "#17507F", "color" : "white", 
		"border" : "1px solid white" }); 
		thzz.showSubMenu(); }, 
		"onmouseout" : function() { thzz.hideSubMenu(); }});	
	var subHolder = createSSElement(subMenu, "div", {					//,   -,  
		"backgroundColor" : "white", "padding" : "3px", 				//   
		"border" : "1px solid black" });
	var navBar = createSSElement(prnt, "div", { 						//    , 
		"position" : "absolute", "top" : "410px", "backgroundColor" : "#17507F",        // "", ""    
		"border" : "1px solid white", "padding" : "0px 4px" }, { 
		"onclick" : preventEvent, "onmousedown" : preventEvent, 
		"onselectstart" : preventEvent });			
	var goForvard = createSSElement(navBar, "span", {					// ""				
		"cursor" : "pointer", "padding" : "0px 3px" }, { 		
		"onmouseup" : function() { if(slEngine[next].moving == false) 
		thzz.switchSlide(true); }, 
		"onmouseover" : function() { changeStyle(goForvard, { 
		"backgroundColor" : "white", "color" : "black" }); }, 
		"onmouseout" : function() { changeStyle(goForvard, { 
		"backgroundColor" : "transparent", "color" : "white" }); }}, 
		"");
	var goBack = createSSElement(navBar, "span", {						// "" 					
		"cursor" : "pointer", "padding" : "0px 3px" }, { 
		"onmouseup" : function() { if(slEngine[next].moving == false) 
		thzz.switchSlide(false); }, 
		"onmouseover" : function() { changeStyle(goBack, { 
		"backgroundColor" : "white", "color" : "black" }); }, 
		"onmouseout" : function() { changeStyle(goBack, { 
		"backgroundColor" : "transparent", "color" : "white" }); }}, 
		"");
	var counter = createSSElement(navBar, "span", {						//  
		"padding" : "0px 3px", "borderLeft" : "1px solid white", "marginLeft" : "3px" }, 
		false, " ");
	var contentBlock = getId("slides");							//,      (div.slide)							
	var getSSItems = function() {								//     "slide",      
		var tempArr = [], allDivs = getTags(contentBlock, "div"), 
		i, l = allDivs.length;
			for(i = 0; i < l; i++) {
      				if(allDivs[i].className == "slide") {
        			tempArr.push(allDivs[i]); }}
				return tempArr; }
	var getSSContent = (function() {							//  (div.slide)   , 					
		tempSlides = getSSItems();		
		var top = getPosY(tempSlides[0], "offsetTop"), 					//       changeStyle()
		i = 0, l = tempSlides.length;						
		for(; i < l; i++) {
			changeStyle(tempSlides[i], { 
			"position" : "absolute", "top" : top, "width" : "425px", "height" : "350px",  
			"backgroundColor" : "#10487E", "overflow" : "hidden","marginLeft" : "5px", 
			"border" : "1px solid white", "padding" : "3px" }); }})();
	var lengthSS = tempSlides.length;							//  
	var counterText = counter.firstChild;
	var contentSLMenu = (function() {							//    ,						
		var originH = [], newH = [], i = 0;						//    -,
		for(; i < lengthSS; i++) {							//     
			originH[i] = getTags(tempSlides[i], "h2")[0].firstChild.nodeValue;	// 
			newH[i] = function(j) { 					
				return createSSElement(subHolder, "div", { 
			 	"cursor" : "pointer", "fontSize" : "11px" }, { 
				"onmouseover" : function() { changeStyle(newH[j], { 
				"color" : "#f60", "textDecoration" : "underline" }); },
				"onmouseout" : function() { changeStyle(newH[j], { 
				"color" : "black", "textDecoration" : "none" }); },
				"onclick" : function() { if(slEngine[next].moving == false) {
		                        active = next;
					next = j;
					changeStyle(navMenu, { "color" : "black", 
					"backgroundColor" : "white", "border" : "none" }); 
					changeStyle(newH[j], { "color" :"black", "textDecoration" : "none" });
					slSubmenu.placeTo(0, -slSubmenu.sHeight);
					if(active != j) { thzz.displaySlide(active, j);
					thzz.showNavBar(j); }
					return next;}}}, originH[j]); }(i)}})();

// - ,     -

	this.showSubMenu = function() {								//   onmouseover   "" 						
		if(timer) clearTimeout(timer);							// -    - 
		slSubmenu.showIt();								//     -
	} 
	this.hideSubMenu = function() {								//   onmouseout   "" 																
		timer = setTimeout(function() { changeStyle(navMenu, { 				// -    -  
			"color" : "black", "backgroundColor" : "white", "border" : "none" }); 	//    "" 
			slSubmenu.hideIt(); }, 500);
	}  
	this.switchSlide = function(bl) {							//           , 	
		active = next;									//  ,     					
		next = getNext(bl);								//        									
		this.displaySlide(active, next);						//,         						
		this.showNavBar(next);								// navBar
		return next;
	}
	this.displaySlide = function(a, n) {							//    ,  						
		if(a >= 0) slEngine[a].slideTo(-slEngine[a].sWidth - 10, closeStep);		//    
		slEngine[n].slideTo(0, openStep);		
	}
	this.showNavBar = function(n) {								//,    navBar  
		counterText.nodeValue = 							//   ,   
		"." + ((n < 9) ? "0" + (n + 1) : n + 1) + "  " + lengthSS;			//  						
		if(n <= 0) goBack.style.visibility = "hidden";
		else goBack.style.visibility = "visible";
		if(n >= lengthSS - 1) goForvard.style.visibility = "hidden";
		else goForvard.style.visibility = "visible";
	}
	function getOwnProps(obj) {
		this.style = obj.style;
		this.sWidth = obj.offsetWidth;
		this.sHeight = obj.offsetHeight;
		this.sTop = obj.offsetTop;
		this.sLeft = obj.offsetLeft;
	}

// - ,       -

	function slideSubMenu(parent, smenu) {							
	        var self = this;
		var step = 5;									// ,    - 
		var isOpen = false;								//   ,    -

//   -    slideSubMenu()

		getOwnProps.call(this, smenu);
		this.pHeight = parent.offsetHeight;

// - ,        -   

		this.clipTo = function(t, r, b, l) {						//,   ""  -
			this.style.clip = "rect(" + t + "px, " + r + "px," + b + "px," + l + "px)";
		}
		this.moveTo = function(x, y) {							//,       
			this.x = Math.floor(x);
			this.y = Math.floor(y);
			this.style.left = this.x + px; 
			this.style.top = this.y + px;
		}
		this.slideTo = function() { 							//,        
			if(isOpen == true) { 
				if(this.y + step <= this.pHeight) { 
					this.clipTo(this.pHeight - this.y - step, this.sWidth, this.sHeight, 0);
					this.moveTo(this.x, this.y + step);
					setTimeout(function() { self.slideTo(); }, 10);
				}
			}
			else if(this.y >= - this.sHeight) { 
				this.clipTo(this.pHeight - this.y + step, this.sWidth, this.sHeight, 0);
				this.moveTo(this.x, this.y - step);
				setTimeout(function() { self.slideTo(); }, 10);
			}
			else return null;
		}
		this.placeTo = function(x, y) {							//      " "
			isOpen = false;
			this.moveTo(x, y);
		}
		this.showIt = function() {							//    -
			if(isOpen == false) {
				isOpen = true;
				this.slideTo();
			}
		}
		this.hideIt = function() {							//    -
			if(isOpen == true) {
				isOpen = false;
				this.slideTo();
			}
		} 
		return this; 
	}

// - ,    ,     

	function slidesEngine(slide, num) {
		this.moving = false;								//,     (   )
	
//       slidesEngine()

		getOwnProps.call(this, slide);		
		
// - ,         

		if(num == 0) { 	
			slidesEngine.prototype.moveTo = slSubmenu.moveTo;			//,      		
	slidesEngine.prototype.slideTo = function(x, step) {			//,    
				var self = this, t;
				if(step > 0) {
					if(this.x < x) { 
						this.moving = true;
						this.moveTo(this.x + step, this.y);
						t = setTimeout(function() { self.slideTo(x, step); }, 10);
					}
					if(this.x + step > x) {
						clearTimeout(t);
						this.moveTo(x, this.y);
						this.moving = false;
					}
				}
				if(step < 0) {
					if(this.x > x) { 
						this.moving = true;
						this.moveTo(this.x + step, this.y);
						t = setTimeout(function() { self.slideTo(x, step); }, 10);
					}
					if(this.x + step < x) {
						clearTimeout(t);
						this.moveTo(x, this.y);
						this.moving = false;
					}
				}					
			}
		}  
		return this;
	}


// -      slideSubMenu()

	var slSubmenu = new slideSubMenu(topBar, subMenu);
	slSubmenu.placeTo(0, -slSubmenu.sHeight);						// - ( )   				
	
// -      slidesEngine()
//  ,       
//  

	var slEngine = [];
	for(var i = 0; i < lengthSS; i++) {
		slEngine[i] = new slidesEngine(tempSlides[i], i);
		slEngine[i].moveTo(-slEngine[i].sWidth - 10, slEngine[i].sTop);
	}
	this.displaySlide(active, next);							//   							
	this.showNavBar(next);									//    navBar								
	return this;
}

// -       onload

onload = function() {										//  onload  									
	if(document.getElementById) { 								//     DOM (to hell with bad browsers!),
		var obj = getId("presentation");						//  div#presentation,    - 
		var slideShow = new mainSSConstructor(obj);					//    -,    
	}											//  -
}